#ifndef KRONOS_EXCEPTION_HEADER
#define KRONOS_EXCEPTION_HEADER

#include <exception>
#include <string>


namespace Kronos {
	namespace Exception {
		class Exception : public std::exception {
			private:
				const std::exception* m_cause;
				const std::string m_message;
				std::string m_trace;

				void initTrace();

			public:
				Exception();
				Exception(const std::string& message);
				Exception(const std::exception& cause);
				Exception(const std::string& message, const std::exception& cause);

				const char* what() const noexcept;
				const std::exception* getCause() const;
				virtual const std::string& getMessage() const;
		};
	}
}

#endif
